Graphics3D 800,600,32,1
SetBuffer BackBuffer()

pxCreateWorld(1,"   !")


AmbientLight 255,255,255

cam = CreateCamera()
PositionEntity cam,0,100,-200
CameraRange cam,.1,99500
;CameraClsColor cam,255,255,255


plane = CreatePlane()
EntityColor plane, 0,128,128

Spetsnaz = LoadAnimMesh("Spetsnaz.b3d")
SpetsnazPX = LoadAnimMesh("SpetsnazPX.b3d")

HideEntity Spetsnaz
HideEntity SpetsnazPX

hero.RagDoll=CreateRagdoll(Spetsnaz, SpetsnazPX,Rand(-100,100),50,Rand(0,100), 0,0 , 0)

Repeat 

	torso=hero\Bones[0]
	;PositionEntity cam,EntityX(torso,1),EntityY(torso,1)+70,EntityZ(torso,1)+100
	PointEntity cam,torso
	
	If KeyDown(57)
		pxBodyAddForce(hero\Bodies[15],0,300,0,1)
	EndIf

	pxRenderPhysic(1,0)
	UpdateRagdolls()
	RenderWorld()
		CameraProject(cam,EntityX(torso,1),EntityY(torso,1),EntityZ(torso,1))
		Text ProjectedX(),ProjectedY(),"assa"

		Text 0,0  , EntityX(torso,1)+" "+EntityY(torso,1)+" "+EntityZ(torso,1)
		Text 0,20, EntityX(cam,1)+" "+EntityY(cam,1)+" "+EntityZ(cam,1)
		Text 0,30, EntityInView(torso,cam)
	Flip
Until KeyHit(1)
End

Type Ragdoll
	Field Mesh ; 
	Field Joints[100] ;  
	Field Bodies[100] ;  
	Field Bones[100] ;  
End Type

Function CreateRagdoll.Ragdoll(man, px,x#,y#,z#, pitch#,yaw#,roll#)
	man = CopyEntity(man)
	EntityAutoFade(man,.1,9900000)
	
	
	PositionEntity man,x,y,z	
	RotateEntity man,Pitch,Yaw,Roll	
	R.Ragdoll = New Ragdoll
	If EntityClass (man) <> "Mesh" Then	
		R\Mesh = GetChild(man,1)
		EntityParent R\Mesh,0
		FreeEntity man
	Else
		R\Mesh = Man
	End If
	CreateHullsForAllChilds(R\Mesh, px, R)
	DeparentAllChilds(R\Mesh)
	Return R
End Function

Function DeparentAllChilds(mesh)
	Repeat
		If CountChildren(mesh) = 0 Then Exit
		DeparentAllChilds(GetChild(mesh,1))	
	Forever 
	EntityParent mesh,0	
End Function

Function UpdateRagdolls()
	For R.Ragdoll = Each Ragdoll
		For i= 0 To 100
			If R\Bodies[i] = 0 Then Exit
			pxBodySetEntity R\Bones[i], R\Bodies[i]
		Next
	Next
End Function

Function CreateHullsForAllChilds(mesh, pxmesh, R.Ragdoll, batya=0)
	HullMesh = FindChild(pxmesh, EntityName(mesh)+"px")
	If HullMesh Then
		Hull = BodyCreateHull(HullMesh, 10)
		pxBodySetPosition Hull, EntityX(Mesh,1), EntityY(Mesh,1), EntityZ(Mesh,1)
		pxBodySetRotation Hull, EntityPitch(Mesh,1), EntityYaw(Mesh,1), EntityRoll(Mesh,1)
		
		For i=0 To 100
			If R\Bodies[i] = 0 Then 
				R\Bodies[i] = Hull
				R\Bones[i] = Mesh
				Exit
			End If
		Next		
		If Batya Then
			Joint = pxJointCreateSpherical (batya,Hull,pxBodyGetPositionX(Hull),pxBodyGetPositionY(Hull),pxBodyGetPositionZ(Hull),0,1,0)
			pxJointSphericalSetLimitAngle(Joint, 30,1, 0)
			pxJointSphericalSetLimitTwist(Joint,-10,10,10,1,0)
			pxJointSphericalSetLimitSpring(Joint, 10, 1, 0)
			For i=0 To 100
			If R\Joints[i] = 0 Then 
				R\Joints[i] = Joint
				Exit
			End If
		Next	
		End If
	End If
	For i=1 To CountChildren(mesh)
		CreateHullsForAllChilds(GetChild(mesh,i), pxmesh, R, Hull)
	Next
End Function

Function BodyCreateHull%(mesh%, mass#)

    Local nsurf = CountSurfaces(mesh)
    Local nvert = 0
    For ns = 1 To nsurf
        Local surf = GetSurface(mesh,ns)
        nvert = nvert + CountVertices(surf)
    Next
         vbank = CreateBank(nvert*4*3)
    nv = 0
    For ns = 1 To nsurf
        surf = GetSurface(mesh,ns)
        nvv = CountVertices(surf)
        For nvc = 0 To nvv - 1
             PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
             PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
             PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
            nv = nv+1
        Next
    Next
    Local bbb%= pxBodyCreateHull(vbank, nvert, mass)
    FreeBank vbank
    Return bbb
End Function
